VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cBMP"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Type BITMAPFILEHEADER
  bfType As Integer
  bfSize As Long
  bfReserved1 As Integer
  bfReserved2 As Integer
  bfOffBits As Long
End Type
Private Type RGBQUAD
    rgbBlue As Byte
    rgbGreen As Byte
    rgbRed As Byte
    rgbReserved As Byte
End Type
Private Type BITMAPINFOHEADER '40 bytes
    biSize As Long
    biWidth As Long
    biHeight As Long
    biPlanes As Integer
    biBitCount As Integer
    biCompression As Long
    biSizeImage As Long
    biXPelsPerMeter As Long
    biYPelsPerMeter As Long
    biClrUsed As Long
    biClrImportant As Long
End Type

Dim Data() As Byte
Dim mWidth As Long
Dim mHeight As Long

Private Function RGBWidth(Width As Long) As Long
RGBWidth = (Width * 3 + 3) And &HFFFFFFFC
End Function

Public Sub LoadFile(ByVal FileName As String)
Dim F As Long, W As Integer, H As Integer, T As Long, B As Byte
Dim BFH As BITMAPFILEHEADER, bih As BITMAPINFOHEADER

F = FreeFile
Open FileName For Binary Access Read As #F
  Get #F, 1, BFH
  Get #F, 1 + Len(BFH), bih
  If Not bih.biBitCount = 24 Then GoTo Erro
  
  mWidth = bih.biWidth
  mHeight = bih.biHeight
  
  W = RGBWidth(bih.biWidth)
  H = bih.biHeight
  
  ReDim Data(1 To W, 1 To H)
  Get #F, 1 + Len(BFH) + Len(bih), Data()
Erro:
Close #F
End Sub

Public Property Get Height() As Long
Height = mHeight
End Property

Public Property Get Width() As Long
Width = mWidth
End Property

Public Property Get Pixel(ByVal x As Long, ByVal y As Long) As Long
On Error GoTo Erro
Dim H As Long, W As Long, T1 As Long, T2 As Long, T3 As Long, T4 As Long

W = UBound(Data, 1)
H = UBound(Data, 2)

T1 = (x - 1) * 3 + 1
T2 = (H - (y - 1))
T3 = T1 + 2
T4 = T1 + 1

If (T3 > W) Or (y > H) Or (x <= 0) Or (y <= 0) Then GoTo Erro

Pixel = RGB(Data(T3, T2), Data(T4, T2), Data(T1, T2))
Exit Property
Erro:
  Pixel = -1
End Property
